"use strict";
var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var util = require("util");
var DynamoUtils = require("../dynamoUtils");
var O = require("that-simple-objectstore");
var _ = require("lodash");
var dynamo_error_1 = require("../errors/dynamo.error");
/**
 * Performs a DynamoDB query
 */
function query(c, cls, options) {
    return __awaiter(this, void 0, void 0, function () {
        var keys_1, dynamoQuery, err_1;
        var _this = this;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    _a.trys.push([0, 2, , 3]);
                    options = options || {};
                    keys_1 = _.keys(options.where || {});
                    dynamoQuery = __assign({ TableName: DynamoUtils.getTableName(cls) }, (function (where) {
                        if (!where) {
                            return {};
                        }
                        var condition = keys_1.map(function (k) { return '#' + k + ' = :' + k; }).join(' and '), names = keys_1.reduce(function (p, k) {
                            var _a;
                            return (__assign({}, p, (_a = {}, _a['#' + k] = k, _a)));
                        }, {}), values = keys_1.reduce(function (p, k) {
                            var _a;
                            return (__assign({}, p, (_a = {}, _a[':' + k] = where[k], _a)));
                        }, {});
                        return {
                            FilterExpression: condition,
                            ExpressionAttributeNames: names,
                            ExpressionAttributeValues: values,
                            ExclusiveStartKey: options.continuationToken
                        };
                    })(options.where));
                    return [4 /*yield*/, util
                            .promisify(c.scan.bind(c))(dynamoQuery)
                            // Convert results into their Model classes
                            .then(function (_a) {
                            var Items = _a.Items, LastEvaluatedKey = _a.LastEvaluatedKey;
                            return __awaiter(_this, void 0, void 0, function () {
                                var res;
                                return __generator(this, function (_b) {
                                    switch (_b.label) {
                                        case 0:
                                            if (!((!options.continuationCount || options.continuationCount > 0) &&
                                                LastEvaluatedKey)) return [3 /*break*/, 2];
                                            return [4 /*yield*/, query(c, cls, __assign({}, options, { continuationToken: LastEvaluatedKey, continuationCount: (options.continuationCount || 10) - 1 }))];
                                        case 1:
                                            res = _b.sent();
                                            return [2 /*return*/, {
                                                    items: [].concat(Items, res.items),
                                                    continuationToken: res.continuationToken
                                                }];
                                        case 2: 
                                        // OTHERWISE
                                        return [2 /*return*/, {
                                                items: (Items || /* istanbul ignore next */ []).map(function (Item) {
                                                    return DynamoUtils.dynamoToClass(cls, Item);
                                                }),
                                                continuationToken: LastEvaluatedKey
                                            }];
                                    }
                                });
                            });
                        })
                            // Perform any additionality filtering specified as part of the query
                            .then(function (data) {
                            return options.filter
                                ? {
                                    items: data.items.filter(options.filter),
                                    continuationToken: data.continuationToken
                                }
                                : data;
                        })
                            // Convert response into a QueryResult
                            .then(function (data) { return ({
                            status: O.ObjectStoreQueryStatus.OK,
                            items: data.items,
                            continuationToken: data.continuationToken
                        }); })];
                case 1: 
                // Create and Run DynamoDB Query
                return [2 /*return*/, _a.sent()];
                case 2:
                    err_1 = _a.sent();
                    // Catch Errors
                    // istanbul ignore next
                    throw new dynamo_error_1.DynamoError('Problem Querying from Dynamo', err_1);
                case 3: return [2 /*return*/];
            }
        });
    });
}
exports.query = query;
