"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var _this = this;
Object.defineProperty(exports, "__esModule", { value: true });
var that_simple_objectstore_1 = require("that-simple-objectstore");
var T = require("../testing");
/**
 * QUERY Tests for Dynamo Objectstore
 */
exports.QUERYTests = function (args) {
    var initDb = function () { return __awaiter(_this, void 0, void 0, function () {
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, T.emptyTable(T.MultiKey)];
                case 1:
                    _a.sent();
                    return [4 /*yield*/, args.objectStore.put(T.multiKey)];
                case 2:
                    _a.sent();
                    return [4 /*yield*/, args.objectStore.put(T.multiKey2)];
                case 3:
                    _a.sent();
                    return [4 /*yield*/, args.objectStore.put(T.multiKey3)];
                case 4:
                    _a.sent();
                    return [4 /*yield*/, args.objectStore.put(T.multiKey4)];
                case 5:
                    _a.sent();
                    return [2 /*return*/];
            }
        });
    }); };
    var validate = function (result, length, first) {
        expect(result).toBeDefined();
        expect(result.status).toBe(that_simple_objectstore_1.ObjectStoreQueryStatus.OK);
        expect(result.items instanceof Array).toBeTruthy();
        expect(result.items.length).toBe(length);
        if (first) {
            expect(result.items[0].hash).toBe(first.hash);
            expect(result.items[0].range).toBe(first.range);
            expect(result.items[0].title).toBe(first.title);
        }
    };
    it('should allow QUERYing of all items', function () { return __awaiter(_this, void 0, void 0, function () {
        var data;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, initDb()];
                case 1:
                    _a.sent();
                    return [4 /*yield*/, args.objectStore.query(T.MultiKey)];
                case 2:
                    data = _a.sent();
                    validate(data, 4);
                    return [2 /*return*/];
            }
        });
    }); });
    it('should allow QUERYing against primary key', function () { return __awaiter(_this, void 0, void 0, function () {
        var data;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, initDb()];
                case 1:
                    _a.sent();
                    return [4 /*yield*/, args.objectStore.query(T.MultiKey, {
                            where: { hash: T.multiKey.hash }
                        })];
                case 2:
                    data = _a.sent();
                    validate(data, 2);
                    return [2 /*return*/];
            }
        });
    }); });
    it('should allow QUERYing against secondary key', function () { return __awaiter(_this, void 0, void 0, function () {
        var data;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, initDb()];
                case 1:
                    _a.sent();
                    return [4 /*yield*/, args.objectStore.query(T.MultiKey, {
                            where: { range: T.multiKey2.range }
                        })];
                case 2:
                    data = _a.sent();
                    validate(data, 1, T.multiKey2);
                    return [2 /*return*/];
            }
        });
    }); });
    it('should allow QUERYing against a searchable attribute', function () { return __awaiter(_this, void 0, void 0, function () {
        var data;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, initDb()];
                case 1:
                    _a.sent();
                    return [4 /*yield*/, args.objectStore.query(T.MultiKey, {
                            where: { title: T.multiKey3.title }
                        })];
                case 2:
                    data = _a.sent();
                    validate(data, 1, T.multiKey3);
                    return [2 /*return*/];
            }
        });
    }); });
    it('should allow QUERYing against a NON searchable attribute', function () { return __awaiter(_this, void 0, void 0, function () {
        var data;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, initDb()];
                case 1:
                    _a.sent();
                    return [4 /*yield*/, args.objectStore.query(T.MultiKey, {
                            where: { description: T.multiKey4.description }
                        })];
                case 2:
                    data = _a.sent();
                    validate(data, 1, T.multiKey4);
                    return [2 /*return*/];
            }
        });
    }); });
    it('should allow QUERYing filters', function () { return __awaiter(_this, void 0, void 0, function () {
        var data;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, initDb()];
                case 1:
                    _a.sent();
                    return [4 /*yield*/, args.objectStore.query(T.MultiKey, {
                            where: { description: T.multiKey4.description },
                            filter: function (item) { return true; }
                        })];
                case 2:
                    data = _a.sent();
                    validate(data, 1, T.multiKey4);
                    return [2 /*return*/];
            }
        });
    }); });
};
