"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var _ = require("lodash");
/**
 * Decodes an object that has been persisted in dynamo
 */
function decodeDynamo(obj) {
    return _.cloneDeepWith(obj, function (value) {
        // Replace EMPTY strings
        if (value === '___EMPTY___') {
            return '';
        }
        // Replace NULL strings
        if (value === '___NULL___') {
            return null;
        }
        // Replace DATE strings
        if (typeof value === 'string' && value.startsWith('___DATE___')) {
            return new Date(value.split('___DATE___').join(''));
        }
    });
}
exports.decodeDynamo = decodeDynamo;
