"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var _ = require("lodash");
/**
 * Encodes an object so it can be persisted into dynamo
 */
function encodeDynamo(obj) {
    return _.cloneDeepWith(obj, function (value) {
        // Replace EMPTY strings
        if (value === '') {
            return '___EMPTY___';
        }
        // Replace NULL strings
        if (value === null) {
            return '___NULL___';
        }
        // Replace DATE strings
        if (value instanceof Date) {
            return '___DATE___' + value.toISOString();
        }
    });
}
exports.encodeDynamo = encodeDynamo;
