"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
/**
 * Returns an Dynamo Key object for a given Model object or class
 */
function getDynamoKey(itemOrClass, partitionKey, sortingKey) {
    var _a;
    var isItem = typeof itemOrClass === 'object';
    var meta = isItem
        ? itemOrClass.meta
        : itemOrClass.meta;
    var key = (_a = {},
        _a[meta.primaryKey] = isItem
            ? itemOrClass[meta.primaryKey]
            : partitionKey,
        _a);
    if (meta.secondaryKey) {
        key[meta.secondaryKey] = isItem
            ? itemOrClass[meta.secondaryKey]
            : sortingKey;
    }
    return key;
}
exports.getDynamoKey = getDynamoKey;
