"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var that_build_library_1 = require("that-build-library");
function InitialiseDynamoDB() {
    return (Promise.resolve()
        /* INITIALISE DYNAMO */
        .then(function () { return that_build_library_1.BuildUtils.echo('Stopping DynamoDB Docker'); })
        .then(function () { return that_build_library_1.BuildUtils.exec('docker', ['stop', 'thatSimpleORM'], true); })
        .catch(function () { })
        .then(function () { return that_build_library_1.BuildUtils.echo('Removing DynamoDB Docker'); })
        .then(function () { return that_build_library_1.BuildUtils.exec('docker', ['rm', 'thatSimpleORM'], true); })
        .catch(function () { })
        .then(function () { return that_build_library_1.BuildUtils.echo('Cleaning'); })
        .then(function () { return that_build_library_1.BuildUtils.clean('db', true); })
        .catch(function () { })
        .then(function () { return that_build_library_1.BuildUtils.echo('Starting DynamoDB Docker'); })
        .then(function () {
        // prettier-ignore
        return that_build_library_1.BuildUtils.exec('docker', ['run',
            '--volume', __dirname + '/../../db:/db',
            '--publish', '8001:8000',
            '--detach',
            '--name', 'thatSimpleORM',
            'amazon/dynamodb-local', '-jar', 'DynamoDBLocal.jar', '-dbPath', '/db',
        ]);
    })
        .catch(console.error)
        .then(function () { return that_build_library_1.BuildUtils.echo('Loading Dot Env'); })
        .then(function () {
        require('dotenv').load();
    }));
}
exports.InitialiseDynamoDB = InitialiseDynamoDB;
